/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_FORMULARIONF
AFTER DELETE OR INSERT OR UPDATE
ON FORMULARIONF FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDCTRLNUMENF;
      END IF;

      IF :OLD.NRCTRLFORMNF IS NOT NULL THEN
         V_DESC := V_DESC || ' CtrlForm=' || :OLD.NRCTRLFORMNF;
      END IF;

      IF :OLD.NRFORMULARNF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrFormul=' || :OLD.NRFORMULARNF;
      END IF;

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || '  Filial=' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.NRLANCTONF IS NOT NULL THEN
         V_DESC := V_DESC || ' NrLancaNF=' || :OLD.NRLANCTONF;
      END IF;

      IF :OLD.IDSTATUSFORM IS NOT NULL THEN
         V_DESC := V_DESC || ' Status=' || :OLD.IDSTATUSFORM;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.NRCTRLFORMNF||:OLD.NRFORMULARNF;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDCTRLNUMENF <> :NEW.CDCTRLNUMENF)  OR
            (:OLD.NRCTRLFORMNF <> :NEW.NRCTRLFORMNF)  OR
            NVL(:NEW.NRFORMULARNF,'!') <> NVL(:OLD.NRFORMULARNF,'!') OR
            NVL(:NEW.CDFILIAL,'!')     <> NVL(:OLD.CDFILIAL,'!') OR
            NVL(:NEW.NRLANCTONF,'!')   <> NVL(:OLD.NRLANCTONF,'!') OR
            NVL(:NEW.IDSTATUSFORM,'!') <> NVL(:OLD.IDSTATUSFORM,'!') THEN


            IF NVL(:NEW.CDCTRLNUMENF,'!') <> NVL(:OLD.CDCTRLNUMENF,'!') THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
            END IF;

            IF NVL(:NEW.NRCTRLFORMNF,'!') <> NVL(:OLD.NRCTRLFORMNF,'!') THEN
               V_DESC := V_DESC || ' CtrlForm=' || :NEW.NRCTRLFORMNF;
            END IF;

            IF NVL(:NEW.NRFORMULARNF,'!') <> NVL(:OLD.NRFORMULARNF,'!') THEN
               V_DESC := V_DESC || ' NrFormul=' || :NEW.NRFORMULARNF;
            END IF;

            IF NVL(:NEW.CDFILIAL,'!') <> NVL(:OLD.CDFILIAL,'!') THEN
               V_DESC := V_DESC || '  Filial=' || :NEW.CDFILIAL;
            END IF;

            IF NVL(:NEW.NRLANCTONF,'!') <> NVL(:OLD.NRLANCTONF,'!') THEN
               V_DESC := V_DESC || ' NrLancaNF=' || :NEW.NRLANCTONF;
            END IF;

            IF NVL(:NEW.IDSTATUSFORM,'!') <> NVL(:OLD.IDSTATUSFORM,'!') THEN
               V_DESC := V_DESC || ' Status=' || :NEW.IDSTATUSFORM;
            END IF;

            V_TIPO         := '1';
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.NRCTRLFORMNF||:OLD.NRFORMULARNF;
         END IF;
      ELSE
         IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.NRCTRLFORMNF IS NOT NULL THEN
            V_DESC := V_DESC || ' CtrlForm=' || :NEW.NRCTRLFORMNF;
         END IF;

         IF :NEW.NRFORMULARNF IS NOT NULL THEN
            V_DESC := V_DESC || ' NrFormul=' || :NEW.NRFORMULARNF;
         END IF;

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || '  Filial=' || :NEW.CDFILIAL;
         END IF;

         IF :NEW.NRLANCTONF IS NOT NULL THEN
            V_DESC := V_DESC || ' NrLancaNF=' || :NEW.NRLANCTONF;
         END IF;

         IF :NEW.IDSTATUSFORM IS NOT NULL THEN
            V_DESC := V_DESC || ' Status=' || :NEW.IDSTATUSFORM;
         END IF;
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDCTRLNUMENF||:OLD.NRCTRLFORMNF||:OLD.NRFORMULARNF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('FORMULARIONF',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_FORMULARIONF','4.09.063'); END;
/

