/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TRANSPORT                                                */
/* Tabela : TRANSPORT                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TRANSPORT'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TRANSPORT
GO

CREATE TRIGGER DTULTATU_TRANSPORT
ON TRANSPORT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TRANSPORT', null, 'IDTPIJURTRAN='+ IDTPIJURTRAN+ ';'+
                                        'NRINSJURTRAN='+ NRINSJURTRAN+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TRANSPORT
      SET DTULTATUTRAN = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TRANSPORT.NMRAZSOCTRAN,0) = ISNULL(INSERTED.NMRAZSOCTRAN,0)) AND
            (ISNULL(TRANSPORT.IDTPIJURTRAN,0) = ISNULL(INSERTED.IDTPIJURTRAN,0)) AND
            (ISNULL(TRANSPORT.NRINSJURTRAN,0) = ISNULL(INSERTED.NRINSJURTRAN,0)) AND
            (ISNULL(TRANSPORT.DSENDETRAN,0)   = ISNULL(INSERTED.DSENDETRAN,0))   AND
            (ISNULL(TRANSPORT.SGESTADO,0)     = ISNULL(INSERTED.SGESTADO,0))     AND
            (ISNULL(TRANSPORT.NRINSESTTRAN,0) = ISNULL(INSERTED.NRINSESTTRAN,0)) AND
            (ISNULL(TRANSPORT.CDPAIS,0)       = ISNULL(INSERTED.CDPAIS,0))       AND
            (ISNULL(TRANSPORT.CDMUNICIPIO,0)  = ISNULL(INSERTED.CDMUNICIPIO,0));
   END;
END;
GO

